display:create("triangulation", 800, 600, 32, true)

terminal = require("utils.log.terminal")

require("lfs")
require("Box2D")
poly2 = require("utils.math.poly2")

local function readfile(fn)
  local f = io.open(fn, "r")
  local fsz = f:read("*a")
  -- polygon
  local p1 = {}
  local p2 = {}
  local state = "polygon"
  for line in string.gmatch(fsz, "[^\n]+") do
    assert(line ~= "")
    local x, y = string.match(line, "([+-]?[%deE.-]+)[%s,]+([+-]?[%deE.-]+)")
    x, y = tonumber(x), tonumber(y)
    if x and y then
      p2[#p2 + 1] = x
      p2[#p2 + 1] = y
    else
      if #p2 > 0 then
        p1[#p1 + 1] = p2
        p2 = {}
      end
    end
  end
  if #p2 > 0 then
    p1[#p1 + 1] = p2
    p2 = {}
  end
  return p1
end

profile = require("utils.log.profile")
profile.hookall("Lua")
profile.setclock(system.get_ticks)

local t1 = system.get_ticks()
local p1 = readfile("utils/math/test/nazca2.txt")[1]
local p1v = poly2.tovectors(p1)
terminal.print(#p1v, "vertices")
local t2 = system.get_ticks()
terminal.print("parsing time", t2 - t1)

--profile.start()
local t1 = system.get_ticks()
local r = poly2.triangulate(p1)
local t2 = system.get_ticks()
--profile.stop()
terminal.print("poly2 time", t2 - t1)

--[[
for i, c, t in profile.query("time", 20) do
  terminal.print(i, c, t)
end
]]


local t1 = system.get_ticks()
local r = b2.Fill(p1v)
local t2 = system.get_ticks()
terminal.print("b2.fill", t2 - t1, r)
