poly = require("utils.math.poly2")

local render = {}

render.style = {}

local curves = require("utils.math.curves")

-- fills a list of paths
function render.fill(paths)
  local alpha = render.style['fill-opacity'] or 1
  local color = render.style['fill'] or 0xffffff
  assert(alpha >= 0 and alpha <= 1)
  assert(color >= 0x0 and color <= 0xffffff)

  local polygons = poly.subpaths(paths)
  
  local verts = {}
  while #polygons > 0 do
    local p = table.remove(polygons)
    if p.sub then
      p = poly.cutholes(p, p.sub)
    end

    poly.triangulate(p, verts)
  end

  local cols = {}--array.uints(#verts/2)
  local alphas = {}--array.floats(#verts/2)
  for i = 1, #verts/2 do
    cols[i] = color
    alphas[i] = alpha
  end
  local s = {}
	s.type = 'triList'
  s.vertices = verts
  s.colors = cols
  s.alpha = alphas
  return s
end

-- strokes a list of paths
function render.stroke(paths, color, alpha)
  -- unsupported
  
end

return render